image: openjdk:8-jdk-slim

variables:
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.color=false -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true -Dmaven.repo.local=.m2/repository"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"
stages:
  - install
  - tests
  - build
  - security

before_script:
  - chmod +x mvnw

dependencies:
  stage: install
  script:
    - ./mvnw $MAVEN_CLI_OPTS dependency:resolve
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: push


build:
  stage: build
  script: ./mvnw $MAVEN_CLI_OPTS clean compile jib:build
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: pull



dependency_scanning:
  image: docker:stable
  stage: security
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run
      --env DEP_SCAN_DISABLE_REMOTE_CHECKS="${DEP_SCAN_DISABLE_REMOTE_CHECKS:-false}"
      --volume "$PWD:/code"
      --volume /var/run/docker.sock:/var/run/docker.sock
      "registry.gitlab.com/gitlab-org/security-products/dependency-scanning:$SP_VERSION" /code
  artifacts:
    paths:
      - gl-dependency-scanning-report.json
    reports:
      dependency_scanning: gl-dependency-scanning-report.json



unit:
  stage: tests
  variables:
    SCOPE: $CI_JOB_NAME
  script: ./mvnw $MAVEN_CLI_OPTS test jacoco:report
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: pull
  artifacts:
    paths:
      - target/site/jacoco/*
    expire_in: 1 week
    when: always
    reports:
      junit:
        - target/surefire-reports/TEST-*.xml
        - target/failsafe-reports/TEST-*.xml



e2e:
  stage: tests
  variables:
    SCOPE: $CI_JOB_NAME
  script: ./mvnw $MAVEN_CLI_OPTS test
  cache:
    paths:
      - .m2/repository/
    key: "$CI_PIPELINE_ID"
    policy: pull
